
<template>
	<header class="mb-3">
		<div class="border border-t-0 h-20 sm:h-24 lg:h-32 relative">

			<button @click="mobileMenuVisible = !mobileMenuVisible" class="absolute px-2 text-lg h-20 inline-flex sm:hidden">
				<span class="self-center">&#9776;</span><!-- Hamburger Icon -->
			</button>

			<!-- TODO: Should be replaced with an image in the future. -->
			<router-link id="logo" class="font-semibold text-lg lg:text-xl h-full flex items-center justify-center" to="/">
				Fake Shop
			</router-link>

		</div>

		<div class="hidden sm:block h-12"><!-- Only visible in sm+ screens. Specified height to prevent layout shift -->
			<ul class="flex flex-row flex-nowrap h-full">
				<li v-for="cat in categories" :key="cat.name" class="category flex-grow text-center py-3 border border-t-0">
					<router-link :to="'/categories/' + cat.slug" class="link">
						{{ cat.name }}
					</router-link>
				</li>
			</ul>
		</div>

		<!-- 
			Mobile menu. Not visible for sm+ screens. Hidden by default, animates to 2/3 width when clicking on the menu button.
		-->
		<div id="mobile-menu" class="sm:hidden fixed z-10 top-0 bottom-0 left-0 bg-white border-r" :class="{ 'w-2/3': mobileMenuVisible }">
			
			<button class="item text-lg w-full h-20 inline-flex border-b py-0 outline-none" @click="mobileMenuVisible = false">
				<span class="self-center">&cross;</span>
			</button>

			<ul class="py-2">
				<li class="item ml-1 list-inside list-square" v-for="cat in categories" :key="cat.name">
					<router-link :to="'/categories/' + cat.slug" class="link" @click="mobileMenuVisible = false">
						{{ cat.name }}
					</router-link>
				</li>
			</ul>

			<hr />

		</div>
		<div id="mobile-overlay" class="sm:hidden fixed inset-0 bg-gray-700" :class="{ 'z-0 opacity-30': mobileMenuVisible }" @click="mobileMenuVisible = false">
			&nbsp;
		</div>

	</header>
</template>

<script>
import categoriesService from '../services/categories-service';

/**
 * Header of the application.
 * Contains the logo and the list of the main product categories.
 * On small screens, the logo is reduced in size and the list of categories is displayed via an hamburger menu.
 */
export default {
	data() {
		return {
			mobileMenuVisible: false,
			categories: []
		}
	},
	async created() {
		this.categories = await categoriesService.getAllCategories();
	}
};
</script>

<style lang="postcss" scoped>

#mobile-menu {
	width: 0;
	overflow: hidden;
	transition: width linear 0.3s;
}

#mobile-overlay {
	opacity: 0;
	transition: opacity linear 0.3s;
	z-index: -1;
}

#mobile-menu .item {
	@apply py-3 pl-2 overflow-hidden whitespace-nowrap;
}

.category + .category {
	border-left: none;
}

</style>
